<SettingsModal tabs={["Basic","Notifications","Presence","Styles"]} bind:selected=tab>
  {#if tab == "Basic"}
  <div class="basic-flex">
    <div class="avatar-flex">
      <AvatarUploader iconUrl={avatarUrl} bind:file=icon />
    </div>
    <div class="options-flex">
      <TextInput name="Username" value={modalContext.username} bind:value=username />
      <Button {disabled} on:click="edit(modalContext, {username}, icon)" text="Apply" />
    </div>

    <Button on:click="logout()"
            color="danger"
            text="Log out" />
  </div>
  {:elseif tab == "Notifications"}
  <div class="notifications-page">
    {#await currentDevicePromise}
    Loading
    {:then currentDevice}
    <Button
      on:click="toggleNotifications(currentDevice)"
      text={(currentDevice && currentDevice.enabled) ? "Disable Notifications" : "Enable Notifications"} />
    {:catch err}
    Heck! {err.message}
    {/await}
  </div>
  {:elseif tab == "Presence"}
  <div class="presence-page">
    <TextInput
      name="Activity"
      bind:value=activity
      value={activity || ""}
      on:change="setActivity(modalContext.id, activity)" />
  </div>
  {:elseif tab == "Styles"}
  <div class="styles">
    <span class="explain-text">
      Write custom CSS here. They won't be sanitised so be certain you trust them!
    </span>
    <CodeEditor language="css" value={$userStyle} on:save="updateStyles(event, modalContext)" />
  </div>
  {:else} something has gone horribly wrong {/if}
</SettingsModal>

<script>
  import SettingsModal from "./SettingsModal.svelte";
  import TextInput from "../forms/TextInput.svelte";
  import Button from "../forms/Button.svelte";
  import RestClient from "../../js/RestClient";
  import UserStore from "../../stores/UserStore";
  import AvatarUploader from "../forms/AvatarUploader.svelte";
  import env from "../../js/constants";
  import * as cryptipush from "../../js/cryptipush";
  import RealTimeClient from "../../js/RealTimeClient";
  import TokenStore from "../../js/TokenStore";

  export default {
    components: {
      SettingsModal,
      TextInput,
      Button,
      AvatarUploader,
      CodeEditor: "../forms/CodeEditor.svelte"
    },
    computed: {
      avatarUrl({modalContext}) {
        return modalContext.avatar
          ? `${env.API_BASE}/avatars/${modalContext.id}/${modalContext.avatar}`
          : null;
      }
    },
    oncreate() {
      this._deviceIdPromise = cryptipush.getDeviceId();
      this.updateDevice();
    },
    onstate({current, changed}) {
      if (changed.modalContext) {
        UserStore.subscribeComponent(
          current.modalContext.id,
          this,
          this.userChange,
          "u"
        );
      }
    },
    methods: {
      async logout() {
        await TokenStore.setToken("");
        this.store.set({
          token: "",
          guildId: null,
          guild: null,
          channels: [],
          chanenlIds: [],
          channel: null,
          guilds: [],
          modal: null,
          username: "Loading",
          userId: undefined,
          discriminator: 0
        });
        RealTimeClient.disconnect();
        // TODO: we need to be able to actually log in again without a reload!!
        location.reload();
      },
      async updateStyles(styles) {
        console.log("updateStyles", styles);
        this.store.set({userStyle: styles});
        await RestClient.patch(
          "/self/styles",
          {
            style: styles
          },
          true
        );
      },
      userChange() {
        const userId = this.get().modalContext.id;
        const user = UserStore.getItem(userId);
        this.set({
          activity: user && user.activity
        });
      },
      setActivity(userId, activity) {
        const user = UserStore.getItem(userId);
        RealTimeClient.setPresence(user && user.presence, activity);
        localStorage.lastActivity = activity;
      },
      updateDevice() {
        this.currentDevicePromise = this._deviceIdPromise
          .then(deviceId =>
            RestClient.get(`/push/devices/${encodeURIComponent(deviceId)}`)
          )
          .catch(() => null);
        this.set({
          currentDevicePromise: this.currentDevicePromise
        });
      },
      async toggleNotifications(device) {
        if (device && device.enabled) {
          await cryptipush.removeSubscription();
        } else {
          if (Notification.permission != "granted") {
            const notificationRes = await Notification.requestPermission();
            if (notificationRes != "granted") {
              return console.warn(
                "User wanted to enable notifs but didn't grant?"
              );
            }
          }
          console.log("Got notification perms!");
          const subscription = await cryptipush.subscribe();
          console.log("Got a subscription!", subscription);
          await cryptipush.publishSubscription(subscription);
        }
        this.updateDevice();
      },
      async edit(user, options, file) {
        const diff = {};
        let modified = false;
        for (const key in options) {
          if (user[key] != options[key]) {
            diff[key] = options[key];
            modified = true;
          }
        }
        if (!modified && file === undefined) {
          return;
        }
        this.set({disabled: true});

        if (modified) {
          try {
            await RestClient.patch("/self", diff);
            UserStore.slurp({id: user.id, ...diff});
          } catch (err) {
            console.error(err);
            return this.set({disabled: false});
          }
        }
        if (file !== undefined) {
          UserStore.slurp({
            id: user.id,
            avatar: (await RestClient.put("/self/avatar", file)).avatar
          });
        }
        this.set({disabled: false});
        this.store.set({modal: null});
      }
    }
  };
</script>

<style>
  .basic-flex {
    display: flexbox;
  }
  .options-flex {
    margin-left: 2em;
  }
  .avatar-flex,
  .options-flex {
    display: inline-block;
  }
  .styles {
    display: flex;
    flex-direction: column;
    height: 90vh;
  }
</style>

